#if !defined(__FLLOPAIF_H)
#define	__FLLOPAIF_H
#include "fllopqps.h"

FLLOP_EXTERN PetscErrorCode FllopAIFInitialize(MPI_Comm comm,int *argc, char ***args);
FLLOP_EXTERN PetscErrorCode FllopAIFInitializeStr(MPI_Comm comm,char *argstr);
FLLOP_EXTERN PetscErrorCode FllopAIFInitializeF(MPI_Fint comm,char *argstr);
FLLOP_EXTERN PetscErrorCode FllopAIFFinalize();

//TODO pointery na pole mohou byt PETSC_NULL!
FLLOP_EXTERN PetscErrorCode FllopAIFSetSolutionVector(PetscInt n,PetscReal *x);
FLLOP_EXTERN PetscErrorCode FllopAIFSetFETIOperator(PetscInt n,PetscInt* i,PetscInt*j,PetscScalar *A);
FLLOP_EXTERN PetscErrorCode FllopAIFSetFETIOperatorNullspace(PetscInt n,PetscInt d,PetscInt* i,PetscInt*j,PetscScalar *R);
FLLOP_EXTERN PetscErrorCode FllopAIFSetFETIOperatorNullspaceDense(PetscInt n,PetscInt d,PetscScalar *R);
FLLOP_EXTERN PetscErrorCode FllopAIFSetOperatorByStripes(PetscInt m,PetscInt n,PetscInt N,PetscInt* i,PetscInt*j,PetscScalar *A);
FLLOP_EXTERN PetscErrorCode FllopAIFSetRhs(PetscInt n,PetscScalar *b);
FLLOP_EXTERN PetscErrorCode FllopAIFSetIneq(PetscInt m,PetscInt n,PetscInt* i,PetscInt*j,PetscScalar *BI,PetscScalar *cI);
FLLOP_EXTERN PetscErrorCode FllopAIFSetEq(PetscInt m,PetscInt n,PetscInt* i,PetscInt*j,PetscScalar *BE,PetscScalar *cE);
FLLOP_EXTERN PetscErrorCode FllopAIFSetBox(PetscInt n,PetscScalar *lb,PetscScalar *ub);
FLLOP_EXTERN PetscErrorCode FllopAIFSetArrayBase(PetscInt base);
FLLOP_EXTERN PetscErrorCode FllopAIFSetType(const char type[]);
FLLOP_EXTERN PetscErrorCode FllopAIFSetDefaultType();

FLLOP_EXTERN PetscErrorCode FllopAIFEnforceEq(PetscBool useP,PetscReal rho);
FLLOP_EXTERN PetscErrorCode FllopAIFHomogenizeEq();
FLLOP_EXTERN PetscErrorCode FllopAIFDualize();
FLLOP_EXTERN PetscErrorCode FllopAIFRegularize(PetscBool explicitly);
FLLOP_EXTERN PetscErrorCode FllopAIFFetiPrepare(PetscBool regularize);

FLLOP_EXTERN PetscErrorCode FllopAIFSolve();

#endif
