#ifdef INC_FLLOP
 #include "fllopaif.h"
#endif

#include "cr.h"
class slesolv;

int slesolv::solver_fllop (comprow *compr,double *rhs, double *lhs)
{
 #ifdef INC_FLLOP
  //  pocet primarnich neznamych na domene
  long n=compr->n;
  
  //  je-li matice v symmetric compressed rows
  //  je treba poskytnout horni trojuhelnik, ne nase symcomprow
  //  TRY(FllopAIFSetFETIOperator (symcompr->n,symcompr->adr,symcompr->ci,symcompr->a, QP_SYM_UPPER_TRIANGULAR) );
  //  je-li v compresser rows
  TRY(FllopAIFSetFETIOperator (compr->n,compr->adr,compr->ci,compr->a, QP_SYM_UNDEF));
  
  //  d - defekt pro jednu podoblast
  long d;
  double *ker;
  ker = new double [n*d];
  //  my musime naplnit pole ker po sloupcich 
  TRY( FllopAIFSetFETIOperatorNullspaceDense(n, d, ker));
  //  rhs - nase prava strana na jedne domene
  TRY( FllopAIFSetRhs(n, rhs));
	
  //  m dualni dimenze - pocet vsech multiplikatoru v uloze
  //  je treba sestavit matici vazeb B do compressed rows
  //  matice B ma tolik radku, kolik je multiplikatoru v cele uloze a tpolik
  //  sloupcu, kolik je posunu na konkretni domene
  //  pokud chceme TFETI, nedefinujeme Dirichletovy podminky, pridame prvky do matice B
  comprow bmat;
  //  vektor prave strany rovbnostnich vazeb - skoky nebo slip mezi domenami
  //  v pripade klasicke dekompozice, sl je nulovy vektor
  double *sl;
  long m = n;
  TRY( FllopAIFSetEq(m, n, PETSC_FALSE, PETSC_TRUE, bmat.adr, bmat.ci, bmat.a, sl));
  TRY( FllopAIFFetiPrepare(PETSC_TRUE,PETSC_TRUE,PETSC_DECIDE) );
  //  lhs je vektor reseni
  TRY( FllopAIFSetSolutionVector(n, lhs) );
  TRY( FllopAIFSolve() );
  TRY( FllopAIFReset() );
 #endif

  return 0;
}
