#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>

#define EXTERN
#define EXTENDED_GLOBINC
#include "global.h"

#include "stochdriver.h"
#include "mefelinit.h"
#include "solverm.h"

int main (int argc,const char *argv[])
{
  time_t bt,et;
  long hod,min;
  double sec = clock();
  stochdriver *stochd;
  stochd = new stochdriver;

  St = NULL ;

  bt = time (NULL);
  //  program initiation and data reading
  mefel_init (argc, argv, stochd);


  //  solution of the problem
  //  the most important function in the code
  solve_mefel_problem (stochd);
  
  
  et = time (NULL);
  fprintf (Out,"\n\n\n Data about computation time \n");
  fprintf (Out,"\n\n Total time of computation             %ld",et-bt);

  sec = (clock() - sec) / (double)CLOCKS_PER_SEC;
  hod = (long)sec/3600;  sec -= hod*3600;
  min = (long)sec/60;    sec -= min*60;
  fprintf (stdout,"\n ----------------------------------");
  fprintf (stdout,"\n Consumed time by MEFEL %ld:%ld:%5f",hod,min,sec);
  fprintf (stdout,"\n ----------------------------------\n");
  
  fprintf (stdout,"\n ----------------------------------");
  fprintf (stdout,"\n Consumed time by MEFEL %ld",et-bt);
  fprintf (stdout,"\n ----------------------------------\n");

  /*  
  fprintf (stdout,"\n ----------------------------------------------");
  fprintf (stdout,"\n Peak of consumed memory of matrix class %ld",give_ammax());
  fprintf (stdout,"\n Peak of consumed memory of vector class %ld",give_avmax());
  fprintf (stdout,"\n ----------------------------------------------\n");
  */
  fprintf (Out,"\n ----------------------------------");
  fprintf (Out,"\n Consumed time by MEFEL %ld:%ld:%5f",hod,min,sec);
  fprintf (Out,"\n ----------------------------------\n");

  fprintf (stdout,"\n\n");  fprintf (stderr,"\n\n");  fprintf (Out,"\n");
  fclose (Out);


  delete stochd;  

  delete Mp;
  delete Gtm;
  delete Mt;
  delete Mm;
  delete Mc;
  delete Mb;

  delete Lsrs;
  delete Ada;
  //delete St;
  delete Outdm;
  delete Fsd;

  delete Smat;
  delete Mmat;
  delete Dmat; 
  delete Ismat;
  delete Amat;

  delete Bar2d;
  delete Bar3d;
  delete Beam2d;
  delete Beam3d;
  delete Spring;
  delete Pelt;
  delete Peqt;
  delete Perlt;
  delete Pelq;
  delete Peqq;
  delete Perlq;
  delete Pesqt;
  delete Cct;
  delete Dkt;
  delete Dst;
  delete Q4pl;
  delete Asymlq;
  delete Asymqq;
  delete Asymlt;
  delete Shtr;
  delete Shq;
  delete Ltet;
  delete Lhex;
  delete Qhex;
  delete Spltr;
  delete Splq;

  return 0;
}
